//
// File:        ncsapi.java
// Author:      Tomasz Stachowiak
// e-mail:      <stach@>
// Created:     Mon Mar  3 1997
// Time-stamp: <97/03/06 20:23:00 stach>
// Copyright Tomasz Stachowiak 1997 NPAC, Syracuse University
// Description:
//

import java.net.*;
import java.io.*;
import java.lang.*;
import java.util.*;

/*
class ncsData implements Runnable {
  DatagramSocket dataSock;
  DatagramPacket packet;
  byte[] buffer;
  const int maxUDPlenght = 65000;
  int appPort;
  ncsApplication app;

  public void Init(ncsApplication application, int port) {
    app = application;
    appPort = port;

    try {
      buffer = new byte[maxUDPlenght];
      packet = new DatagramPacket(buffer, maxUDPlenght);
      dataSock = new DatagramSocket(appPort);
    } catch () {
      System.out.println("ncsData: " + e);
    }
  }

  public void Quit() {
    dataSock.close();
  }

  public int Send(InetAddress addr, byte[] data, int len) {
    DatagramPacket pack = new DatagramPacket(data, len, addr, appPort);

    try {
      dataSock.send(pack);
    } catch (IOException e) {
      System.out.println("ncsData: " + e);
      return 0;
    }

    return 1;
  }


  public void run() {
  }  
}
*/

class ncsAPI implements Runnable {
  InetAddress daemonAddr;
  static int daemonPort = 5000;
  Socket ctrlSock;
  DataInputStream in;
  DataOutputStream out;
  Hashtable members;
  //ncsData data;
  //Thread dataThread;
  Thread thread;
  ncsApplication app;
  int handle;
  static int headerSize = 56;
  int appPort;

  public ncsAPI(ncsApplication application, int port) {
    app = application;
    appPort = port;
    //data = new ncsData(app, port);    
    handle = -1;
  }

  public void Attach() {
    try {
      daemonAddr = InetAddress.getLocalHost();
      ctrlSock = new Socket(daemonAddr, daemonPort);
      in = new DataInputStream(ctrlSock.getInputStream());
      out = new DataOutputStream(ctrlSock.getOutputStream());
    } catch(UnknownHostException e) {
      System.out.println("ncsAPI: " + e);
    } catch(IOException e) {
      System.out.println("ncsAPI: " + e);
    }

    //data.Init();
    //dataThread = newThread(data);
    //dataThread.start();
    thread = new Thread(this);
    thread.start();

    byte[] tab = new byte[2];
    tab[0] = (byte)(appPort/256);
    tab[1] = (byte)(appPort % 256);
    engineRequest(63, tab, 2);
    
  }

  public void Dettach() {
    byte[] tab = new byte[2];
    tab[0] = (byte)(appPort/256);
    tab[1] = (byte)(appPort % 256);
    engineRequest(50, null, 0);
    thread.stop();
    try {
      ctrlSock.close();
    } catch(IOException e) {
      System.out.println("ncsAPI: " + e);
    }
    //dataThread.stop();
    //data.Quit();
  }

  protected int engineRequest(int tag, byte[] data, int len) {
    byte[] tab = new byte[49];

    try {
      out.write(tag);
      out.write(0);
      out.write(handle);
      out.write(tab, 0, 49);
      out.writeInt(len);
      if(data != null)
	out.write(data, 0, len);
      out.flush();
    } catch (IOException e) {
      System.out.println("ncsAPI: " + e);
      return 0;
    }
          
    return 1;
  }

  /*
  public int SendData(int user, int tag, byte[] data, int len) {
    if(user >= 0) {
      InetAddress addr = members.get(user);
      if(addr != null) {
	data.Send(addr, msg, lenght);
      }
    }
      
    return 1;
  }*/


  public int SendPriorityData(int user, int tag, byte[] data, int len) {
    ByteArrayOutputStream bufout = new ByteArrayOutputStream();
    DataOutputStream dataout = new DataOutputStream(bufout);
    try {
      dataout.write(handle);
      dataout.write(handle);
      dataout.write(handle);
      dataout.write(handle);
      dataout.writeInt(user);
      dataout.writeInt(appPort);
      dataout.writeShort(tag);
      if(data != null)
	dataout.write(data);
      else
	dataout.writeByte(handle);

      byte[] appdata = bufout.toByteArray();
	

      engineRequest(51, appdata, appdata.length);

    } catch(IOException e) {
      System.out.println("ncsAPI: " + e);
    }

    return 1;
  }


  private void dataHandle(byte[] msg, int len) {
    int pom, tag, user;
    ByteArrayInputStream inbuf = new ByteArrayInputStream(msg);
    DataInputStream indata = new DataInputStream(inbuf);
    try {
      user = indata.readByte();
      indata.readByte();
      indata.readByte();
      indata.readByte();
      indata.readInt();
      indata.readInt();
      tag = indata.readShort();
      byte[] data = new byte[indata.available()];
      indata.read(data);

      app.dataCallback(user, tag, data, data.length);
    } catch (IOException e) {
      System.out.println("ncsAPI: " + e);
    }
  }

  private void starting(byte[] msg) {
    ByteArrayInputStream inbuf = new ByteArrayInputStream(msg);
    DataInputStream indata = new DataInputStream(inbuf);
    try {
      handle = indata.readInt();
    } catch (IOException e) {
      System.out.println("ncsAPI: " + e);
    }
    app.startingCallback();
  }

  private void msgHandle(int tag, byte[] data, int len) {
    switch(tag) {
    case 52:      // indAppData
      dataHandle(data, len);
      break;

    case 17:      // indLocalSessionAddMember
      app.addMbrCallback();
      break;

    case 18:      // indLocalSessionDeleteMember
      app.delMbrCallback();
      break;

    case 19:      // indLocalSessionLocalMember
      starting(data);
      break;

    case 23:      // indLocalAppQuit
      app.quitCallback();
      break;

    case 24:      // indDbStart
      break;

    case 25:      // indDbStop
      break;

    default:
      System.out.println("ncsAPI: wrong control message tag " + tag);
    } 
  }

  public void run() {
    byte[] hdr = new byte[headerSize - 4];
    int len;
    byte[] buf;

    while(true) {
      try {
	in.read(hdr);
	len = in.readInt();

	if(len > 0) {
	  buf = new byte[len];
	  in.read(buf);
	}
	else
	  buf = null;
	
	
	//	System.out.println("ncsAPI: message read; tag: "+hdr[0]+" length: "+len);
	msgHandle(hdr[0], buf, len);
      } catch (IOException e) {
	System.out.println("ncsAPI: " + e);
      }
    }
  }
}







